

package CompileZ;

/** 
 * Complie Z. 
 * @author  Slim KALLEL
 * @version 1.0 20-11-06
 */



import java.io.*;
import java.util.*;
import javax.swing.JOptionPane;



class AspectGeneration{
	
	
	ExtractZInformation Z;
	TranslateOperators trs;
	TranslatePredicates prd;
	String Zfile;
	String StSchema;
	String path;
	boolean isPetriNet;
	String[] alltransition;
	boolean automatic;
	public AspectGeneration(String Zfile,String StSchema,String path1, boolean isPetri, String[] transition, boolean automatic){
		this.Zfile=Zfile;
		this.StSchema= StSchema;
		Z = new ExtractZInformation(Zfile);
		Z.StyleSchema(StSchema);
		trs = new TranslateOperators(Zfile,StSchema);	
		path=path1;
		isPetriNet=isPetri;
		alltransition=transition;
		this.automatic=automatic;
	}
	
	int nbExceptionPc;boolean exceptionExecuted=false;
	int nbConst=0;
	int refSurNbFFinalCons=0; 
	String CompRelatModified [];int crModified;


	public static void main(String []args)
	{	
	}
	
	/******************************Creation of SystemState file ******************************/
	/**
	 * 
	 */
	public void GenerateSystemState() {
		
		try{

		FileWriter StateWriter = new FileWriter(path+"\\"+"SystemState.java");
		StateWriter.write("\n class SystemState{");
		StateWriter.write("\n\t\t/*-------------System State---------------*/\n");   	
     	/*
     	 * Declaration of Component Tables
     	 */

     	for(int i=0;i<Z.nbC;i++){
     		StateWriter.write("\n \t static String [] "+Z.TabComp[i][0]+ "= new String [100];\n");
     		StateWriter.write("\t static String [] Old"+Z.TabComp[i][0]+";\n");
     		StateWriter.write("\t static String [] New"+Z.TabComp[i][0]+";\n");
     		StateWriter.write("\t static int nb"+Z.TabComp[i][0]+"=0;");
     	}
     	/*
     	 * Declaration of Relation Tables
     	 */
     	for(int i=0;i<Z.nbR;i++){
     		StateWriter.write("\n \t static String [][] "+Z.TabRelat[i][0]+"= new String [100][2];\n");
     		StateWriter.write("\t static String [][] Old"+Z.TabRelat[i][0]+";\n");
     		StateWriter.write("\t static String [][] New"+Z.TabRelat[i][0]+";\n");
     		StateWriter.write("\t static int nb"+Z.TabRelat[i][0]+"=0;");
     	}
     	
 		
 	
     	
     	
		StateWriter.write("\n}");
		StateWriter.close();
		}catch(Exception e){
			System.out.println("System state Exception...");
		}
	}
	
	/**
	 * 
	 * @param OpSchema
	 * @param CompDec
	 * @param TypeOperation
	 */
	
	public void createAspect(String OpSchema){

			Z.OperationSchema(OpSchema);
			MappingPointCut pc= new MappingPointCut(OpSchema);
			String pointcut=pc.getPointCut();
			nbExceptionPc=0;
			if(pointcut.equals(""))
				nbExceptionPc++;

			int NbConsTotal=0;
			
			CompRelatModified = new String [100];crModified=0;
			
	try {
		
		
			/********************************Cretaion of Operation Aspect *********************************/

            FileWriter writer = new FileWriter(path+"\\"+OpSchema+".aj");
			writer.write("\n public aspect "+ OpSchema+"{\n\n");
         	writer.write("\t pointcut "+ pointcut+"\n\n");
         	writer.write("\n");        	
         	writer.write("\n\t\t/*------------Update the System Sate----------------*/\n");
         	/*
         	 *Extract the declaration from components schemas
         	 */  
         	String CorespInput[][]= new String [Z.nbI][2];
         	String declaration="";
         	for(int i=0;i<Z.nbI;i++){
         		String Comp=Z.TabInput[i][1];
         		String TabProprieties [] = Z.getInformation(Comp);
         		declaration=declaration+","+TabProprieties[1]+" "+TabProprieties[0];
         		CorespInput[i][0]=Z.TabInput[i][0];
         		CorespInput[i][1]=TabProprieties[0];
         	}
         	
         	
         	declaration=declaration.substring(1,declaration.length());	
         	writer.write("\n\n \t void getNewState("+declaration+"){\n");
         	for(int i=0;i<Z.nbC;i++){
         		writer.write("\t\t SystemState.Old"+Z.TabComp[i][0]+ "= new String [SystemState.nb"+Z.TabComp[i][0]+"];\n");
         	}    	
         	for(int i=0;i<Z.nbR;i++){
         		writer.write("\t\t SystemState.Old"+Z.TabRelat[i][0]+"= new String [SystemState.nb"+Z.TabRelat[i][0]+"][2];\n");
         	}   	
         	for(int i=0;i<Z.nbC;i++){
         		writer.write("\n\t\t for(int i=0;i<SystemState.nb"+Z.TabComp[i][0]+";i++)  ");
         		writer.write("\n\t\t\t SystemState.Old"+Z.TabComp[i][0]+"[i]=SystemState."+Z.TabComp[i][0]+"[i];");
         	}       	
         	for(int i=0;i<Z.nbR;i++){
         		writer.write("\n\t\t for(int i=0;i<SystemState.nb"+Z.TabRelat[i][0]+";i++)  ");
         		writer.write("\n\t\t\t SystemState.Old"+Z.TabRelat[i][0]+"[i]=SystemState."+Z.TabRelat[i][0]+"[i];");
         	}
         	
       
			
			writer.write("\n");		
			String UpdateState="";
         	for(int i=0;i<Z.nbPost;i++){         		
         		StringTokenizer st = new StringTokenizer(Z.TabPost[i]);
         		String new1 = st.nextToken();
         		new1 = new1.substring(0,new1.length()-1);
         		if(existeInTab(new1,CompListe(Z.TabComp)))
         		{
	         		if(Z.exist(Z.TabPost[i], "\\setminus")){
	         			CompRelatModified[crModified]=new1;
	         			crModified++;
	         			
	         			int acoladGauxh=Z.TabPost[i].indexOf("{");
	         			int acoladDroit=Z.TabPost[i].indexOf("}");
	         			
	         			String input=Z.TabPost[i].substring(acoladGauxh+1,acoladDroit-1);
	         			
	         			String inputPresentat=Z.TabPost[i].substring(acoladGauxh+1,acoladDroit-2);
	         			inputPresentat=inputPresentat+"Input";

	         			String s1="";
	         			for(int j=0;j<Z.nbI;j++)
	         				if(input.equals(CorespInput[j][0]))
	         						 s1=CorespInput[j][1];

		         		writer.write("\t\t SystemState.New"+new1+"= new String [SystemState.nb"+new1+"-1];\n");
		         		writer.write("\t\t SystemState.New"+new1+"=ZOpeartors.getSetDifference(SystemState.Old"+new1+","+s1+");\n");
		         		
		         		UpdateState=UpdateState+"\n\t\t\t int k=0;";
		         		UpdateState=UpdateState+"\n\t\t\t for(int i=0; i<SystemState.nb"+new1+";i++)";
		         		UpdateState=UpdateState+"\n\t\t\t\t if(SystemState."+new1+"[i].equals("+inputPresentat+"))";
		         		UpdateState=UpdateState+"\n\t\t\t\t\t k=i;";
		         		UpdateState=UpdateState+"\n\t\t\t while(k<SystemState.nb"+new1+"){";
		         		UpdateState=UpdateState+"\n\t\t\t\t SystemState."+new1+"[k]=SystemState."+new1+"[k+1];";
		         		UpdateState=UpdateState+"\n\t\t\t\t k++;";
		         		UpdateState=UpdateState+"\n\t\t\t }";
		         		UpdateState=UpdateState+"\n\t\t\t SystemState.nb"+new1+"--;";	
	         		}
	         			
	         		else if((Z.exist(Z.TabPost[i], "\\cup"))||(Z.exist(Z.TabPost[i], "\\cat"))){
	         			CompRelatModified[crModified]=new1;
		         		crModified++;
	
	         			int acoladGauxh=Z.TabPost[i].indexOf("{");
	         			int acoladDroit=Z.TabPost[i].indexOf("}");
	         			
	         			String input=Z.TabPost[i].substring(acoladGauxh+1,acoladDroit-1);
	         			String inputPresentat=Z.TabPost[i].substring(acoladGauxh+1,acoladDroit-2);
	         			inputPresentat=inputPresentat+"Input";
	         			String s1="";
	         			for(int j=0;j<Z.nbI;j++)
	         				if(input.equals(CorespInput[j][0]))
	         						 s1=CorespInput[j][1];

		         		writer.write("\t\t SystemState.New"+new1+"= new String [SystemState.nb"+new1+"+1];\n");
		         		writer.write("\t\t SystemState.New"+new1+"=ZOpeartors.getSetUnion(SystemState.Old"+new1+","+s1+");\n");

		         		UpdateState=UpdateState+"\n\t\t\t SystemState."+ new1+"[SystemState.nb"+new1+"]="+inputPresentat+";";
		         		UpdateState=UpdateState+"\n\t\t\t SystemState.nb"+new1+"++;";

	         		}
	         		else {
	         			writer.write("\t\t SystemState.New"+new1+"= new String[SystemState.nb"+new1+"];\n");
	         			writer.write("\t\t SystemState.New"+new1+"=  SystemState.Old"+new1+";\n");
		         	}	
	         	}
         		
         		
	         	if(existeInTab(new1,CompListeR(Z.TabRelat)))
         		{
	         		if(Z.exist(Z.TabPost[i], "\\setminus")){
	         			CompRelatModified[crModified]=new1;
	         			crModified++;

	         			int parGauxh=Z.TabPost[i].indexOf("(");
	         			int virgul=Z.TabPost[i].indexOf(",");
	         			int parDroit=Z.TabPost[i].indexOf(")");
	         			
	         			String input1=Z.TabPost[i].substring(parGauxh+1,virgul);
	         			String input2=Z.TabPost[i].substring(virgul+2,parDroit);
	         			
	         			String inputPresentat1=input1.substring(0,input1.length()-1);
	         			String inputPresentat2=input2.substring(0,input2.length()-1);
	         			
	         			inputPresentat1=inputPresentat1+"Input";
	         			inputPresentat2=inputPresentat2+"Input";
	         			
	         			String s1="";
	         			for(int j=0;j<Z.nbI;j++)
	         				if(input1.equals(CorespInput[j][0]))
	         						 s1=CorespInput[j][1];
	         			String s2="";
	         			for(int j=0;j<Z.nbI;j++)
	         				if(input2.equals(CorespInput[j][0]))
	         						 s2=CorespInput[j][1];
	         			
		         		writer.write("\t\t SystemState.New"+new1+"= new String [SystemState.nb"+new1+"-1][2];\n");
		         		writer.write("\t\t SystemState.New"+new1+"=ZOpeartors.getSetDifference(SystemState.Old"+new1+","+s1+","+s2+");\n");
		         		
		         		UpdateState=UpdateState+"\n\t\t\t int k=0;";
		         		UpdateState=UpdateState+"\n\t\t\t for(int i=0; i<SystemState.nb"+new1+";i++)";
		         		UpdateState=UpdateState+"\n\t\t\t\t if((SystemState."+new1+"[i][0].equals("+inputPresentat1+"))||(SystemState."+new1+"[i][1].equals("+inputPresentat2+")))";
		         		UpdateState=UpdateState+"\n\t\t\t\t\t k=i;";
		         		UpdateState=UpdateState+"\n\t\t\t while(k<SystemState.nb"+new1+"){";
		         		UpdateState=UpdateState+"\n\t\t\t\t SystemState."+new1+"[k][0]=SystemState."+new1+"[k+1][0];";
		         		UpdateState=UpdateState+"\n\t\t\t\t SystemState."+new1+"[k][1]=SystemState."+new1+"[k+1][1];";
		         		UpdateState=UpdateState+"\n\t\t\t\t k++;";
		         		UpdateState=UpdateState+"\n\t\t\t }";
		         		UpdateState=UpdateState+"\n\t\t\t SystemState.nb"+new1+"--;";
		         		
	         			}
	         			
	         		else if(Z.exist(Z.TabPost[i], "\\cup")){
	         			CompRelatModified[crModified]=new1;
	         			crModified++;

	         			int parGauxh=Z.TabPost[i].indexOf("(");
	         			int virgul=Z.TabPost[i].indexOf(",");
	         			int parDroit=Z.TabPost[i].indexOf(")");
	         			
	         			String input1=Z.TabPost[i].substring(parGauxh+1,virgul);
	         			String input2=Z.TabPost[i].substring(virgul+2,parDroit);

	         			String inputPresentat1=input1.substring(0,input1.length()-1);
	         			String inputPresentat2=input2.substring(0,input2.length()-1);
	         			
	         			inputPresentat1=inputPresentat1+"Input";
	         			inputPresentat2=inputPresentat2+"Input";
	         			
	         			
	         			String s1="";
	         			for(int j=0;j<Z.nbI;j++)
	         				if(input1.equals(CorespInput[j][0]))
	         						 s1=CorespInput[j][1];
	         			
	         			String s2="";
	         			for(int j=0;j<Z.nbI;j++)
	         				if(input2.equals(CorespInput[j][0]))
	         						 s2=CorespInput[j][1];
	         				         			
		         		writer.write("\t\t SystemState.New"+new1+"= new String [SystemState.nb"+new1+"+1][2];\n");
		         		writer.write("\t\t SystemState.New"+new1+"=ZOpeartors.getSetUnion(SystemState.Old"+new1+","+s1+","+s2+");\n");
         		
		         		UpdateState=UpdateState+"\n\t\t\t SystemState."+ new1+"[SystemState.nb"+new1+"][0]="+inputPresentat1+";";
		         		UpdateState=UpdateState+"\n\t\t\t SystemState."+ new1+"[SystemState.nb"+new1+"][1]="+inputPresentat2+";";
		         		UpdateState=UpdateState+"\n\t\t\t SystemState.nb"+new1+"++;";

	         			}
	         		else {
	         			writer.write("\t\t SystemState.New"+new1+"= new String[SystemState.nb"+new1+"][2];\n");
	         			writer.write("\t\t SystemState.New"+new1+"= SystemState.Old"+new1+";\n");
		         		}	
	         	}
         	}
         	writer.write("\t }\n");
         	
         	
         	/*
         	 * Define the content of around and content of the pointcut name and the content of proceed
         	 */
         	writer.write("\n\t\t/*------------Around Advice----------------*/\n");

         	String [][] TabVirgDetail= new String[100][2];
         	String VarVirgVar="";
         	int par1=pointcut.indexOf("(");
         	int par2=pointcut.indexOf(")");
         	

         	String namePC=pointcut.substring(0,par1);
         	String declar=pointcut.substring(par1+1,par2);
         	int vir=declar.indexOf(",");
         	
         	
         	if(vir>(0)){         	
	         	int [] TabVirg = new int[100];int nb=0;
	         	TabVirg[0]=0;
	         	for(int j=0;j<declar.length()-1;j++){
					String carac=declar.substring(j,j+1);
					if(carac.equals(",")){
						nb++;	
						TabVirg[nb]=j;
					} 
				}
				TabVirg[(nb+1)]=declar.length();int k=nb+1;
				String [] ConteDeclar = new String[k];
				ConteDeclar[0]=declar.substring(TabVirg[0],TabVirg[1]);
				for(int l=1;l<k;l++){
						ConteDeclar[l]=declar.substring(TabVirg[l]+1,TabVirg[l+1]);
					}
			 	for(int l=0;l<k;l++){	
			 		int space=ConteDeclar[l].indexOf(" ");
			 		TabVirgDetail[l][0]=ConteDeclar[l].substring(0,space);
			 		TabVirgDetail[l][1]=ConteDeclar[l].substring(space+1,ConteDeclar[l].length());
			 		VarVirgVar+=TabVirgDetail[l][1]+",";
			 	}
				VarVirgVar=VarVirgVar.substring(0,VarVirgVar.length()-1);
				
			}
			else if(!declar.equals("")){
				int space=declar.indexOf(" ");
				TabVirgDetail[0][0]=declar.substring(0,space);
			 	TabVirgDetail[0][1]=declar.substring(space+1,declar.length());
			 	VarVirgVar=TabVirgDetail[0][1];
			}

         	if(automatic)
         		writer.write("\n \t\t  /* Change the return type of your poincut */");
			
			if(automatic)
				writer.write("\n\t void around("+declar+"): "+namePC+"("+VarVirgVar+"){\n");
			else
				writer.write("\n\t ....... around("+declar+"): "+namePC+"("+VarVirgVar+"){\n");
			
         	writer.write("\t\t try{\n");

         				
			writer.write("\n\t\t/*------------Declaration of Input Component----------------*/\n");
         	
			
         	String StringID= "";
         	
         	if(automatic)
         		writer.write("\n \t\t  /* Choose the correspond component to the attribute */");
         	
         	String appelgetNewState="";
         	for(int i=0;i<Z.nbI;i++){
         		StringID=Z.TabInput[i][0];
				StringID=StringID.substring(0,StringID.length()-1);
				String iduniq=StringID;
				StringID=StringID+"Input";

         		String Comp=Z.TabInput[i][1];
         		String TabProprieties [] = Z.getInformation(Comp);
         		if(automatic)
         			writer.write("\n\t\t String "+StringID +"="+ iduniq+"."+TabProprieties [0]+";");
         		else
         			writer.write("\n\t\t String "+StringID +"="+ TabProprieties [0]+";");
         		appelgetNewState=appelgetNewState+","+StringID;
         		
         		
         	}
			
         	appelgetNewState=appelgetNewState.substring(1,appelgetNewState.length());
     		

			writer.write("\n\t\t/*------------Call getNewState for Update the System State----------------*/\n");
			writer.write("\n \t\t getNewState("+appelgetNewState+");\n \t\t int nbConstraints=0;\n");

			
			if(isPetriNet && existInTab(OpSchema, alltransition))
			{
				//if(automatic)
				//	writer.write("\n\n\n\t\t int n=getNum(sInput,SystemState.Oldsections,nbsections);");
				// else
					writer.write("\n\n\n\t\t int n=0;");
				
				writer.write("\n\t\t if(!PetriSystemState.isUpdate)");
				writer.write("\n\t\t PetriSystemState.getState();");
				writer.write("\n\t\t int []tab=PetriSystemState.getPreConditon(PetriSystemState."+OpSchema+");");
				writer.write("\n\t\t if(PetriSystemState.isTransisitionEnabled(tab,n)){");
				writer.write("\n\t\t nbConstraints++;");
				writer.write("\n\t\t }else{");
				writer.write("\n\t\t System.out.println(\"The Petri >>>>>  The transisition"+ OpSchema+" is not Enabled\");");
				writer.write("\n\t\t }");
				NbConsTotal++;
			}
				
			
			
			
			
     		writer.write("\n\t\t/*------------Constraint from Operation schema----------------*/\n");
     		String Const="";
     		for(int i=0; i<Z.nbPre;i++){
         		Const=Z.TabPre[i];
         		Const=Replace(Const);        		
         		trs.NorO="Old";

         		
	         	writer.write("\n\t\t if("+trs.recu(Const)+"){\n");
				writer.write("\t\t\t nbConstraints++ ; \n");	
				writer.write("\t\t }\n \t\t else{\n");
				writer.write("\t\t\t System.out.println(\""+OpSchema+" >>>>> Constraint number "+(i+1)+" in "+OpSchema+" schema not satisfied \");\n \t\t }");
				NbConsTotal++;
			}

				
			writer.write("\n\t\t/*------------Constraint from Domain Range----------------*/\n");
			String ConstDR="";
     		for(int i=0; i<Z.nbDR;i++){
         		trs.NorO="New";	

             	if((choixConstraints(Z.TabDomRan[i][1])) || (choixConstraints(Z.TabDomRan[i][3])))
         		
         			{
         				ConstDR= Z.TabDomRan[i][0]+"  "+Z.TabDomRan[i][1]+" "+Z.TabDomRan[i][2]+"  "+Z.TabDomRan[i][3];
         				writer.write("\n\t\t if("+trs.recu(ConstDR)+"){\n");
						writer.write("\t\t\t nbConstraints++ ;\n");	
						writer.write("\t\t }\n \t\t else{\n");
						writer.write("\t\t\t System.out.println(\""+OpSchema+" >>>>>  Constraint number "+(i+1)+" in system schema not satisfied \");\n \t\t }");
         				NbConsTotal++;
         			}	
     		}
     		

     		

     		
     		writer.write("\n\t\t/*------------Constraints from System Schema----------------*/\n");
			String SinpleConst="";
			for(int i=0; i<Z.nbSC;i++){         			
     			SinpleConst=Z.SimpleConst[i];	
     			trs.NorO="New"; 
     			
     			for(int j=0;j<crModified;j++) 
     			if(choixConstraints(SinpleConst)){         			
     				writer.write("\n\t\t if("+trs.recu(SinpleConst)+"){\n");
					writer.write("\t\t\t nbConstraints++ ;\n");	
					writer.write("\t\t }\n \t\t else{\n");
					writer.write("\t\t\t System.out.println(\""+OpSchema+" >>>>>  Constraint number "+(i+1+Z.nbDR)+" in system schema not satisfied \");\n \t\t }");        		
     				NbConsTotal++;
     			}
     		}
     		
         		
         		
         		
         		
         		
         		
     		writer.write("\n\t\t/*------------Complexe Constraints from Style Schema----------------*/\n");
     		String QConst="";
			for(int i=0; i<Z.nbQC;i++){  
					String QConstVerif=Z.QuantConst[i];
					if(choixConstraints(QConstVerif)){   				
         				writer.write("\n\t\t if(Qconst"+i+"()){\n");
						writer.write("\t\t\t nbConstraints++ ;\n");	
						writer.write("\t\t }\n \t\t else{\n");
						writer.write("\t\t\t System.out.println(\""+OpSchema+" >>>>> Constraint number "+(i+1+Z.nbDR+Z.nbSC)+" in system schema not satisfied \");\n \t\t }");
         				NbConsTotal++;
     				}
     		}
         		
         		
         		
         		
         		
         		         		
 			writer.write("\n\t\t/*------------Verify the number of constraints----------------*/\n");
			writer.write("\n\t\t if(nbConstraints=="+NbConsTotal+"){");
			writer.write("\n\t\t\t	proceed("+VarVirgVar+");");
			
			if(isPetriNet && existInTab(OpSchema, alltransition)){
				writer.write("\n\t\t\t	PetriSystemState.UpdateNewState(PetriSystemState."+OpSchema +",n);");
			}
			
			writer.write(""+UpdateState);
			
					
			if(automatic)
				writer.write("\n\t\t/*Write here the return type of your poincut*/");
			

			
									
			writer.write("\n\t\t }");
			writer.write("\n\t\t else{");
			writer.write("\n\t\t System.out.println(\"===>>> The "+OpSchema+" Aspect is not executed \");");
			writer.write("\n\t\t }");
			
									
     		writer.write("\n\t\t}\n");
			writer.write("\t\t catch(Exception e){System .out.println(\"AspectException :\"+ e);}\n\t\t}");
			writer.write("\n\n");
			
			
			
			

			
			writer.write("\n\t\t/*------------Quantifier Constraints from style schema -----------------------*/\n");
   			for(int i=0; i<Z.nbQC;i++){
      				QConst=Z.QuantConst[i];
      				if(choixConstraints(QConst)){
     				prd = new TranslatePredicates(Zfile,StSchema);
     				String condition="";
     				String propreConst="";
     				int bar=QConst.indexOf("|");
      				if(bar>(-1)){
      						
      					int valueConst=0;
     					
     					for(int j=0;j<QConst.length()-1;j++){
						String carac=QConst.substring(j,j+1);
						if(carac.equals("@"))
							valueConst=j;
						}
						
     					int cons=valueConst;
     					condition= QConst.substring(bar+2,cons-1);
     					propreConst= QConst.substring(cons+2,QConst.length()-2);
     					
     				}
     				else{
     					int valueConst=0;
     					
     					for(int j=0;j<QConst.length()-1;j++){
							String carac=QConst.substring(j,j+1);
							if(carac.equals("@"))
								valueConst=j;
						}
						propreConst= QConst.substring(valueConst+2,QConst.length()-2);
     				}
     				
     				String finalTab[][]=QuantConstMeth(QConst);

     				writer.write("\n\t\t boolean Qconst"+i+"(){");
     				writer.write("\n\t\t\t boolean constraints=true;");	 				
	 				for(int s=0;s<refSurNbFFinalCons;s++)
	 				{
	 					if(finalTab[s][0].equals("forall"))
	 						writer.write("\n\t\t\t boolean result"+s+"=true;");
	 					if(finalTab[s][0].equals("exist"))
	 						writer.write("\n\t\t\t boolean result"+s+"=false;");
	 				}
	 				String b="";
	 				for(int s=0;s<refSurNbFFinalCons;s++)
	 				{
	 					if(finalTab[s][0].equals("forall"))
	 						b="";
	 					if(finalTab[s][0].equals("exist"))
	 						b="!";
	 					writer.write("\n\t\t\t\t String [] Tab"+s+"=SystemState.New"+finalTab[s][2]+";");
						writer.write("\n\t\t\t while ((Tab"+s+".length!=0)&& "+b+"result"+s+")\n\t\t\t {");
						writer.write("\n\t\t\t\t String "+ finalTab[s][1] +" =getElement(Tab"+s+");");
	 				}
	 				trs.NorO="New";
	 				if(!condition.equals("")){
	 					writer.write("\n\t\t\t\t if("+prd.constraint(condition)+"){");	
	 				}
	 				writer.write("\n\t\t\t\t\t\t constraints ="+prd.constraint(propreConst)+";");
	 				for(int s=refSurNbFFinalCons-1;s>-1;s--)
	 				{
	 					if(finalTab[s][0].equals("forall"))
	 						writer.write("\n\t\t\t\t result"+s+"=result"+s+" && constraints;");
	 					if(finalTab[s][0].equals("exist"))
	 						writer.write("\n\t\t\t\t result"+s+"= constraints;");
	 				
	 				}
	 				if(!condition.equals("")){
	 						writer.write("\n\t\t\t\t }");	
	 				}
	 				for(int s=refSurNbFFinalCons-1;s>-1;s--)
	 				{
	 					writer.write("\n\t\t\t\t Tab"+s+"=getNewTab(Tab"+s+");");
		 				writer.write("\n\t\t\t }");
		 			}
     				writer.write("\n \t\t\t return result"+0+";");
     				writer.write("\n\t\t }\n\n\n");
     				}	
     			}
	         	writer.write("\n\n\n\n");		
 			 


	         	
	         	
 			 writer.write("\n\t\t/*------------Other methods for Quantifier Constraints -----------------------*/\n");
 		 	 writer.write("\n\t\tString  getElement (String [] Tab){");
			 writer.write("\n\t\t\tString ele = Tab[(Tab.length-1)];");
			 writer.write("\n\t\t\treturn ele;");
		 	 writer.write("\n\t\t	}");
		 
		     writer.write("\n\t\tString [] getNewTab(String [] Tab){");
			 writer.write("\n\t\t\tString []TabTemp = new String[Tab.length-1];");
			 writer.write("\n\t\t\t for (int i=0; i<(Tab.length-1);i++){");
			 writer.write("\n\t\t\t\t TabTemp[i]=Tab[i];");
			 writer.write("\n\t\t\t}");
			 writer.write("\n\t\t\tTab=TabTemp;");
			 writer.write("\n\t\t\t return Tab;");
			 writer.write("\n\t\t }");
       		 
       		writer.write("\n \n \t static int getNum (String input, String Tab[], int n){");
       		writer.write("\n \t \t	int num=0;boolean exist=false;");
       		writer.write("\n \t \t	 while(num<n && !exist){");
       		writer.write("\n \t \t	 if(input.equals(Tab[num]))");
       		writer.write("\n \t \t	 exist=true;");
       		writer.write("\n \t \t	 num++;");
       		writer.write("\n \t \t	}");
       		writer.write("\n \t \t	return num;");
       		writer.write("\n \t }");
    		
       		
      		writer.write("\n\t}\n\n\n");
      		 
      		 
         	writer.close();  
     
        }
        catch(Exception exc){
        	if((nbExceptionPc>0) && (!exceptionExecuted)){
        		JOptionPane.showMessageDialog(null, "Check your PointCut in the XML file", "Error",JOptionPane.ERROR_MESSAGE);
        		System.out.println("Check your PointCut in the XML file");
        		exceptionExecuted=true;
        	}
        	System.out.println("Aspect Generation Exception "+exc);	
        }
	
	}
	
	
	
	public boolean choixConstraints(String constr){	
		//System.out.println("??"+constr+"??"+crModified);
		int i=0;
		boolean exist=false;
		while((i<crModified)&& !exist){	
			if((constr.indexOf(CompRelatModified[i]))>(-1)){
				exist=true;
			}
			i++;
		}
		return exist;	
	}
	
	
	

 	public boolean existeInTab(String ele, String [] set)
	{
		boolean includ=true;
		int i=0;int nb=0;
		while((i<set.length)&& (includ)){
			if(!(ele.equals(set[i]))){
				nb++;}
			if(nb==set.length)
				includ=false;
			i++;
		}
		return includ;
	}
	
	
	
	

	public String[] CompListe(String [][]e)
	{
		String [] TComp = new String[Z.nbC];
         for(int i=0;i<Z.nbC;i++){  
           TComp[i]=e[i][0];
         } 	
         return TComp;
	}
	public String[] CompListeR(String [][]e)
	{
		String [] TComp = new String[Z.nbR];
         for(int i=0;i<Z.nbR;i++){  
           TComp[i]=e[i][0];
         } 	
         return TComp;
	}
	
	
	

	public void regalge(String predicat,int[] ConsQuan, int nbConsQuan){
		ConsQuan[0]=0;
		for(int i=0;i<predicat.length()-2;i++){
				String carac=predicat.substring(i,i+1);
				if(carac.equals("@")){
					nbConsQuan++;
					ConsQuan[nbConsQuan]=i;
				}
			}
			predicat=predicat.substring(0,ConsQuan[nbConsQuan]-1);
	}
	
	

	public String[][] QuantConstMeth(String predicat){
		String [][]TabQanTotal= new String [100][3]; 
		int c=predicat.indexOf("|");
		int [] ConsQuan = new int[100];
		int nbConsQuan=0;
		boolean existe=false;
		if(c>(-1)){
			predicat=predicat.substring(0,c-1);
			existe=true;
				nbConsQuan=0;
				ConsQuan[0]=0;
				for(int i=0;i<predicat.length()-2;i++){
						String carac=predicat.substring(i,i+1);
						if(carac.equals("@")){
							nbConsQuan++;
							ConsQuan[nbConsQuan]=i;
						}
					}
					if(nbConsQuan!=0){
						nbConsQuan++;
						ConsQuan[nbConsQuan]=c;}
			}
		else{
				nbConsQuan=0;	
				ConsQuan[0]=0;
				for(int i=0;i<predicat.length()-2;i++){
						String carac=predicat.substring(i,i+1);
						if(carac.equals("@")){
							nbConsQuan++;
							ConsQuan[nbConsQuan]=i;
						}
					}
					predicat=predicat.substring(0,ConsQuan[nbConsQuan]-1);
			
			}
		if((nbConsQuan==0 && existe)||(nbConsQuan==1 && !existe)){
				String [][] Temp=TabVarType(predicat);
				int u=0;
				while(u<totalFianlCons)
					{
						TabQanTotal[u][0]=Temp[u][0];
						TabQanTotal[u][1]=Temp[u][1];
						TabQanTotal[u][2]=Temp[u][2];
						u++;
					}
					refSurNbFFinalCons=totalFianlCons;

			}
		else{
			String [] ConsSepare = new String[(nbConsQuan+1)];
			String cq0= predicat.substring(ConsQuan[0],(ConsQuan[1]-1));
			ConsSepare[0]=cq0;
						
			for(int z=1;z<(nbConsQuan);z++){
				
				int a=ConsQuan[z]+2;
				int b=ConsQuan[z+1]-1;
				
				String cq= predicat.substring(a,b);
				
				ConsSepare[z]=cq;
			}
			
			int TotalDuTotal=0; int nbConParEqu=0;
			for(int p=0;p<(nbConsQuan);p++){
			
			
			String [][] Temp= TabVarType(ConsSepare[p]);
			int u=0;
			
			while(u<totalFianlCons)
			{
			
				TabQanTotal[nbConParEqu][0]=Temp[u][0];
				TabQanTotal[nbConParEqu][1]=Temp[u][1];
				TabQanTotal[nbConParEqu][2]=Temp[u][2];
				nbConParEqu++;u++;
				
			}
			
			TotalDuTotal+=totalFianlCons;
			}
			refSurNbFFinalCons=TotalDuTotal;
			TotalDuTotal=0;					
		}
		
	return TabQanTotal;
	}
	


	 // Add The word "Input" for the imput parameters in the operation schema
	 
	public String Replace(String Cons){
		
		String [] TabTemp = new String[Z.nbI];
			for(int i=0;i<Z.nbI;i++){			
				TabTemp[i]=Z.TabInput[i][0];
				String s= TabTemp[i].substring(0,(TabTemp[i].length()-1));
				s=s+"Input";
				if((Cons.indexOf(TabTemp[i]))>(-1)){
					Cons=Cons.replace(TabTemp[i],s);
				}
			}
	return Cons;	
	}
	
	
	
	int totalFianlCons=0;

	
	public String[][] TabVarType (String predicat)
	{
		totalFianlCons=0;
		String [][]TabQanClassif= new String [100][3]; int nbVar=0;
		int [] potvir = new int[100];
		int compteur=0;//int j=0;
		potvir[compteur]=0;
		int pointvirg = predicat.indexOf(";");
		int sp = predicat.indexOf(" ");
		String tt=predicat.substring(1,sp);
		
		if(pointvirg>(-1))
		{
			for(int i=0;i<predicat.length()-2;i++){
				String carac=predicat.substring(i,i+1);
				if(carac.equals(";")){
						compteur++;
						potvir[compteur]=i;
				}
			}
			potvir[compteur+1]=predicat.length();
		
			for(int y=0;y<compteur+1;y++){
				String s1=predicat.substring(potvir[y]+1,potvir[(y+1)]);
				int compteurVir=0;
				int space = s1.indexOf(" ")-1;
				int deuxpoint = s1.indexOf(":");
				int virg = s1.indexOf(",");
				int [] Tabvir = new int[100];
				Tabvir[0]=space;
				if(virg>(-1)){

					for(int i=0;i<s1.length();i++){
						String carac=s1.substring(i,i+1);
						if(carac.equals(",")){
							compteurVir++;
							Tabvir[compteurVir]=i;
							}
							
					}
					
					Tabvir[compteurVir+1]=deuxpoint;
					
					for(int a=0;a<compteurVir+1;a++){
						
						
						String g=s1.substring(0,space+1);
						if(g.equals(""))
							TabQanClassif[nbVar][0]=TabQanClassif[nbVar-1][0];
						else
							TabQanClassif[nbVar][0]=s1.substring(0,space+1);
						String s2=predicat.substring(Tabvir[a]+3,Tabvir[(a+1)]+1);
						TabQanClassif[nbVar][1]=s2;
						TabQanClassif[nbVar][2]=s1.substring(deuxpoint+2,s1.length());
						nbVar++;
						totalFianlCons++;
					}
				}// fin de if avec virgule
				else{
						String kk=s1.substring(space+2,deuxpoint);
						String rr=s1.substring(deuxpoint+2,s1.length());
						TabQanClassif[nbVar][0]=tt;
						TabQanClassif[nbVar][1]=kk;
						TabQanClassif[nbVar][2]=rr;
						nbVar++;						
						totalFianlCons++;
					}
			}
	
		}
		else{ //pas de pointVirgule
			
			String s1=predicat.substring(1,predicat.length());
			
				int compteurVir=0;
				int space = s1.indexOf(" ")-1;
				int deuxpoint = s1.indexOf(":");
				int virg = s1.indexOf(",");
				int [] Tabvir = new int[100];
				Tabvir[0]=space;
			
			if(virg>(-1))
					{
						for(int i=0;i<s1.length();i++){
							String carac=s1.substring(i,i+1);
							if(carac.equals(",")){
								compteurVir++;
								Tabvir[compteurVir]=i;
								}
						}
						Tabvir[compteurVir+1]=deuxpoint;
						for(int a=0;a<compteurVir+1;a++){
							String s2=predicat.substring(Tabvir[a]+3,Tabvir[(a+1)]+1);
							TabQanClassif[nbVar][0]=s1.substring(0,space+1);
							TabQanClassif[nbVar][1]=s2;
							TabQanClassif[nbVar][2]=s1.substring(deuxpoint+2,s1.length());
							nbVar++;						
							totalFianlCons++;
						}
					}// fin de if avec virgule
					else{
						String kk=s1.substring(space+2,deuxpoint);
						String rr=s1.substring(deuxpoint+2,s1.length());
						TabQanClassif[nbVar][0]=tt;
						TabQanClassif[nbVar][1]=kk;
						TabQanClassif[nbVar][2]=rr;
						nbVar++;						
						totalFianlCons++;
					}
				//	WithoutPV=nbVar;
			
		}
		return TabQanClassif;
		
	}
	
	public boolean existInTab (String s, String []Tab){
		int i=0; boolean exist=false;
		while(i<Tab.length && !exist){
			if(s.equals(Tab[i]))
				exist=true;
			i++;
		}
			
		return exist;
	}
	
	
}